/* BeEyes.cpp
   Copyright (C) 1996, 1997, 1998 ABiSoft, Inc. (bedev@abisoft.com)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

// This source is based on code written by Benoit Schillings,
// the original heading comments follow.

//******************************************************************************
//
//	File:		BeEyes.cpp
//
//	Description:	BeEyes main
//
//	Written by:	Benoit Schillings, drastically 
//	changed by Abraham Flaxman and ABiSoft, Inc.
//
//	Copyright 1993, Be Incorporated
//
//	Change History:
//
//	7/31/93		bgs	new today
//	12/14/95	CKH	removing menu stuff
//  7/16/98     Some other stuff happened earlier. Making it replicable.
//
//******************************************************************************

#include <SupportDefs.h>
#include <Application.h>
#include <Alert.h>
#include <GraphicsDefs.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "t3d.h"
#include <math.h>
#include "TMy3d.h"
#include "EyeView.h"
#include "SmartSingleWindow.h"
#include "Preferences.h"
#define PREF_STRING	  "x-vnd.abisoft-BeEyes"
#define PREF_BASE		"application/"
double MyAcos(double argument);
//J Watte's shared library stuff
Preferences gPrefs(PREF_STRING);
PreferenceSet gSettings(gPrefs, "settings", true);

/*------------------------------------------------------------*/

class	TMainWindow : public SmartSingleWindow {
public:
	TMainWindow(BRect bound,
				int32 numOfEyes,
	   			char *name,
	   			window_type Wtype,
	   			long flags);
};

/*------------------------------------------------------------*/

TMainWindow::TMainWindow(BRect bound, int32 numOfEyes, char *name, 
		window_type type, long flags) :
		SmartSingleWindow(bound, name, type, flags)
{
	bound.OffsetTo(B_ORIGIN);
	EyeView *eyeView = new EyeView(bound, numOfEyes);
	AddChild(eyeView);
	Show();
}

/*------------------------------------------------------------*/
int main(void)
{
	char		buf[1024];
	
	sprintf(buf, "%s%s", PREF_BASE, PREF_STRING );
	
	
	BApplication my_app(buf);
	int32 numOfEyes = 2; //This is the number of eyes to display. It
						 //Can be any perfect square, or 2
	float side = 100 + sqrt(numOfEyes) * 99 + 7; 
  	BRect a_rect(100, 100, side, side);
	if(numOfEyes == 2)
		a_rect.Set(100, 100, 100 + 2 * 99 + 7, 199 + 7);
  	
	TMainWindow *a_window = new TMainWindow (a_rect, numOfEyes, "BeEyes", B_TITLED_WINDOW,
					B_NOT_RESIZABLE|B_NOT_ZOOMABLE|B_WILL_ACCEPT_FIRST_CLICK);
	if(numOfEyes <= 2)
		set_thread_priority(a_window->Thread(), B_NORMAL_PRIORITY);
	if(numOfEyes <= 9)
		set_thread_priority(a_window->Thread(), B_DISPLAY_PRIORITY);
	else
		set_thread_priority(a_window->Thread(), B_REAL_TIME_PRIORITY);
		
	
	my_app.Run();
}
